#include <iostream>
#include <fstream>
using namespace std;

ifstream fin("schi.in");
ofstream fout("schi.out");

const int NMax = 30005;

int n, st[4 * NMax], ord[NMax], loc[NMax];
// st[x] = nr valorilor de 1 in intervalul [l, r]

void Update(int x, int l, int r, int poz, int v)
{
    int m = (l + r) / 2;
    if (l == r)
    {
        st[x] = v;
        return;
    }

    if (poz <= m)
        Update(2 * x, l, m, poz, v);

    if (poz > m)
        Update(2 * x + 1, m + 1, r, poz, v);

    st[x] = st[2 * x] + st[2 * x + 1];
}

int Query(int x, int l, int r, int k)
{
    if (l == r)
        return l;

    int m = (l + r) / 2;

    if (st[2 * x] >= k)
        return Query(2 * x, l, m, k);

    return Query(2 * x + 1, m + 1, r, k - st[2 * x]);
}

int main()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
    {
        fin >> loc[i];
        Update (1, 1, n, i, 1);
    }

    for (int i = n; i >= 1; --i)
    {
        int loc_real = Query(1, 1, n, loc[i]);
        ord[loc_real] = i;
        Update(1, 1, n, loc_real, 0);
    }

    for (int i = 1; i <= n; ++i)
        fout << ord[i] << '\n';

    return 0;
}
