#include <fstream>
#include <climits>
using namespace std;

const int DIM = 100010,
          INF = INT_MAX,
          MOD = 9901;

ifstream fin ("aepim.in");
ofstream fout("aepim.out");

int A[4 * DIM][3][3];
int n, m, a, b, t, mini[3][3], x, k, aux[3][3];

void Decod(int x, int k, int a[3][3])
{
    for (int i = k - 1; i >= 0; --i)
        for (int j = k - 1; j >= 0; --j) 
        {
            a[i][j] = x % 10;
            x /= 10;
        }
}

void Prod(int a[3][3], int b[3][3], int c[3][3], int K) 
{
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < k; ++j) 
        {
            c[i][j] = 0;
            for (int k = 0; k < K; ++k) 
            {
                c[i][j] += a[i][k] * b[k][j];
                c[i][j] %= MOD;
            }
        }
}

void Copy(int a[3][3], int b[3][3], int k) 
{
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < k; ++j)
            a[i][j] = b[i][j];
}

void Write(int a[3][3], int k) 
{
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < k; ++j)
            fout << a[i][j] << ' ';
    fout << '\n';
}

void Identity(int a[3][3], int k) 
{
    for (int i = 0; i < k; ++i)
        for (int j = 0; j < k; ++j) 
            if (i == j)
                a[i][j] = 1;
            else
                a[i][j] = 0;
}

void Build(int x, int l, int r) 
{
    if (l == r) 
    {
        fin >> x;
        Decod(x, k, A[x]);
        return;
    } 
	int m = (l + r) / 2;
	Build(2 * x, l, m);
	Build(2 * x + 1, m + 1, r);
	Prod(A[2 * x], A[2 * x + 1], A[x], k);
}

void Query(int x, int l, int r, int a, int b) 
{
    if (a <= l && r <= b) 
    {
        Prod(mini, A[x], aux, k);
        Copy(mini, aux, k);
        return;
    }
	int m = (l + r)/2;
	if (a <= m)
		Query(2*x, l, m, a, b);
	if (b > m)
		Query(2*x+1, m+1, r, a, b);
}

void Update(int x, int l, int r, int a, int b) 
{
    if (l == r) 
    {
        Decod(b, k, A[x]);
        return;
    } 
	int m = (l + r)/2;
	if (a <= m)
		Update(2 * x, l, m, a, b);
	if (a > m)
		Update(2 * x + 1, m + 1, r, a, b);

	Prod(A[2 * x], A[2 * x + 1], A[x], k);
}

int main () 
{
    fin >> n >> k;
    Build(1, 1, n);
    fin >> m;
    for (int i = 1; i <= m; ++i) 
    {
        fin >> t >> a >> b;
        if (t == 1) 
        {
            Identity(mini, k);
            Query(1, 1, n, a, b);
            Write(mini, k);
        } 
        else 
            Update(1, 1, n, a, b);
    }
    return 0;
}
