// OK
#include <fstream>
#include <algorithm>
#include <vector>
using namespace std;

ifstream fin("aimi.in");
ofstream fout("aimi.out");
const int INF = 0x3f3f3f3f;

class SegTree {
public:
	SegTree(int n) :
		n {n},
		mi {vector<long long>(4 * n)},
		lz {vector<long long>(4 * n, -1)}
    {
        Build(1, 1, n);
	}

	void Update(int L, int R, int X)
	{
		this->L = L; this->R = R;
		Update(1, 1, n, X);
	}

	long long Query(int _L, int _R)
	{
		L = _L; R = _R;
		return Query(1, 1, n);
	}

	void Build()
	{
		Build(1, 1, n);
	}
protected:
	void Update(int x, int l, int r, int X)
	{
		Propagate(x, l, r);

		if (L <= l && r <= R)
		{
			lz[x] = X;
			Propagate(x, l, r);
			return;
		}

		if (l > r || l > R || r < L) return;

		int m = (l + r) / 2;
		Update(2 * x, l, m, X);
		Update(2 * x + 1, m + 1, r, X);

		mi[x] = min(mi[2 * x], mi[2 * x + 1]);
	}

	long long Query(int x, int l, int r)
	{
		Propagate(x, l, r);

		if (L <= l && r <= R)
			return mi[x];

		if (l > r || l > R || r < L)
			return INF;

		int m = (l + r) / 2;
		return min(Query(2 * x, l, m), Query(2 * x + 1, m + 1, r));
	}

	void Propagate(int x, int l, int r)
	{
		if (lz[x] != -1)
		{
			mi[x]  = lz[x];
			if (l != r)    /// daca x are fii
			{
				lz[2 * x]     = lz[x];
				lz[2 * x + 1] = lz[x];
			}
			lz[x] = -1;
		}
	}

	void Build(int x, int l, int r)
	{
		if (l == r)
		{
			fin >> mi[x];
			return;
		}

		int m = (l + r) / 2;
		Build(2 * x, l, m);
		Build(2 * x + 1, m + 1, r);
		mi[x] = min(mi[2 * x], mi[2 * x + 1]);
	}

private:
	int n, L, R;
	vector<long long> mi, lz;
};

int main()
{
	int n, m, op, L, R, X;
    fin >> n;

    SegTree s(n);
    //s.Build();

    fin >> m;
    while (m--)
    {
        fin >> op >> L >> R;
        if (op == 1)
            fout << s.Query(L, R) << '\n';
        else
        {
			fin >> X;
            s.Update(L, R, X);
		}
    }

    return 0;
}
