#include <fstream>
#include <climits>
using namespace std;

#define DIM 100010
#define INF INT_MAX

ifstream fin ("aecmmdci.in");
ofstream fout("aecmmdci.out");

int A[4 * DIM];
int n, m, a, b, t;

int Cmmdc(int a, int b) 
{
    int r;
    while (b) 
    {
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

void Build(int nod, int st, int dr) 
{
    if (st == dr) 
    {
        fin >> A[nod];
        return;
    }
	int mid = (st + dr) / 2;
	Build(2 * nod, st, mid);
	Build(2 * nod + 1, mid + 1, dr);
	A[nod] = Cmmdc(A[2 * nod], A[2 * nod + 1]);
}

int Query(int nod, int st, int dr, int a, int b) 
{
	if (a <= st && dr <= b) 
        return A[nod];
   
    
	int mid = (st + dr) / 2;
	int c1 = 0, c2 = 0;
	if (a <= mid)
		c1 = Query(2 * nod, st, mid, a, b);
	if (b > mid)
		c2 = Query(2 * nod + 1, mid + 1, dr, a, b);
	return Cmmdc(c1, c2);
}

void Update(int nod, int st, int dr, int a, int b) 
{
    if (st == dr) 
    {
        A[nod] = b;
        return;
    }

	int mid = (st + dr)/2;
	if (a <= mid)
		Update(2 * nod, st, mid, a, b);
	if (a > mid)
		Update(2 * nod + 1, mid + 1, dr, a, b);
	A[nod] = Cmmdc(A[2 * nod], A[2 * nod + 1]);

}

int main () 
{
    fin >> n;
    Build(1, 1, n);
    
    fin >> m;
    for (int i = 1; i <= m; ++i) 
    {
        fin >> t >> a >> b;
        if (t == 1) 
            fout << Query(1, 1, n, a, b) << '\n'; 
        else 
            Update(1, 1, n, a, b);
    }
    return 0;
}
