#include <fstream>
#include <climits>
using namespace std;

#define DIM 100010
#define INF INT_MAX

ifstream fin ("aemi.in");
ofstream fout("aemi.out");

int A[4 * DIM];
int n, m, a, b, t, i, minim;

void build(int nod, int st, int dr)
{
    if (st == dr)
    {
        fin >> A[nod];
        return;
    }

	int mid = (st + dr)/2;
	build(2 * nod, st, mid);
	build(2 * nod + 1, mid + 1, dr);
	A[nod] = min(A[2 * nod], A[2 * nod + 1]);
}

int query(int nod, int st, int dr, int a, int b)
{
    if (a <= st && dr <= b)
        return a[st];

	int mid = (st + dr) / 2;
	int m1 = INF, m2 = INF;
	if (a <= mid)
		m1 = query(2 * nod, st, mid, a, b);
	if (b > mid)
		m2 = query(2 * nod + 1, mid + 1, dr, a, b);
    return min(m1, m2);
}

void update(int nod, int st, int dr, int poz, int val)
{
    if (st == dr)
    {
        A[nod] = val;
        return;
    }
	int mid = (st + dr) / 2;
	if (poz <= mid)
		update(2 * nod, st, mid, poz, val);
	if (poz > mid)
		update(2 * nod + 1, mid + 1, dr, poz, val);
	A[nod] = min(A[2 * nod], A[2 * nod + 1]);
}

int main ()
{

    fin >> n;
    build(1, 1, n);
    fin >> m;
    for (int i = 1; i <= m; ++i)
    {
        fin >> t >> a >> b;
        if (t == 1)
        {
            minim = INF;
            query(1, 1, n, a, b);
            fout << minim << "\n";
        }
        else
            update(1, 1, n, a, b);
    }
    return 0;
}
