#include <fstream>
#define INF 2000000001
#define DIM 100010
using namespace std;

ifstream fin ("aesm.in");
ofstream fout("aesm.out");


struct Node {
    int mini;    /// val miniima din intervalul [l, r] asociat nodului
    int pos;    /// poz miniimului in intervalul [st, dr]
    int cnt;    /// numarul de elem ale sirului dat ramase nesterse in intervalul [st, dr] asociat nodului curent
};

Node A[DIM * 4];


void Build(int x, int l, int r)
{
    if (l == r)
    {
        fin >> A[x].mini;
        A[x].pos = l;  // poz elementului in sirul de elemente
        A[x].cnt = 1;
        return;
    }

	int mid = (l + r) / 2;
	Build(2 * x, l, mid);
	Build(2 * x + 1, mid + 1, r);

	A[x].mini = A[2 * x].mini;
	A[x].pos = A[2 * x].pos;

	if (A[2 * x + 1].mini < A[x].mini)
	{
		A[x].mini = A[2 * x + 1].mini;
		A[x].pos = A[2 * x + 1].pos;
	}

	A[x].cnt = A[2 * x].cnt + A[2 * x + 1].cnt;
}

void Update(int x, int l, int r, int pos, int v)
{
    if (l == r)
    {
        A[x].mini = v;
        A[x].pos = l;
        if (v == INF)    // daca trebuie sters elem de la pozitia pos
            A[x].cnt = 0;
        else
            A[x].cnt = 1;
        return;
    }

	int mid = (l + r) / 2;
	if (pos <= mid)
		Update(2 * x, l, mid, pos, v);
	if (pos > mid)
		Update(2 * x + 1, mid + 1, r, pos, v);

	A[x].mini = A[2 * x].mini;
	A[x].pos = A[2 * x].pos;

	if (A[2 * x + 1].mini < A[x].mini)
	{
		A[x].mini = A[2 *x + 1].mini;
		A[x].pos = A[2 * x + 1].pos;
	}

   // A[x].cnt - nr de elemente nesterse din intervalul [l, r]
    A[x].cnt = A[2 * x].cnt + A[2 * x + 1].cnt;
}

int GetPoz(int x, int l, int r, int p) // caut poz in sirul a[]
{                                      // la care mai sunt p valori nesterse
	if (l == r)
        return l;

	int mid = (l + r) / 2;

	if (A[2 * x].cnt >= p)
		return GetPoz(2 * x, l, mid, p);

	return GetPoz(2 * x + 1, mid + 1, r, p - A[2 * x].cnt);
}

int main()
{
	int n, m, x, t, p;
    fin >> n;

    Build(1, 1, n);

    fin >> m;
    for (int i = 1; i <= m; ++i)
    {
        fin >> t;
        if (t == 1)
        {
            fout << A[1].mini << "\n";
            Update(1, 1, n, A[1].pos, INF); // stergem minimul
        }
        else
        {
            fin >> p >> x;
            int pos = GetPoz(1, 1, n, p); // poz in sir al celui de-al "p" lea element nesters
            Update(1, 1, n, pos, x);
        }
    }
    return 0;
}
