#include <fstream>
#include <climits>
using namespace std;

const int DIM = 100010, INF = INT_MAX;

ifstream fin("aimi.in");
ofstream fout("aimi.out");

struct nod {
    int value;
    bool lazy;
};

nod A[4 * DIM];
int n, m, a, b, t, i, minim, x;

void Build(int nod, int st, int dr);
void Query(int nod, int st, int dr, int a, int b); 
void Update(int nod, int st, int dr, int a, int b, int x);

void PushDown(int nod)
{
	// propagare spre fii
	if (A[nod].lazy ) 
	{
		A[2 * nod].value = A[nod].value;
		A[2 * nod].lazy = true;
		A[2 * nod + 1].value = A[nod].value;
		A[2 * nod + 1].lazy = true;
		A[nod].lazy = false;
	}
}

int main() 
{
    fin >> n;
    Build(1, 1, n);
    fin >> m;
    for (int i = 1; i <= m; ++i) 
    {
        fin >> t >> a >> b;
        if (t == 1) 
        {
            minim = INF;
            Query(1, 1, n, a, b);
            fout << minim << "\n";
        } 
        else 
        {
            fin >> x;
            Update(1, 1, n, a, b, x);
        }
    }
    return 0;
}


void Build(int nod, int st, int dr) 
{
    if (st == dr) 
    {
        fin >> A[nod].value;
		return;
    }
  
	int mid = (st + dr) / 2;
	Build(2 * nod, st, mid);
	Build(2 * nod + 1, mid + 1, dr);
	A[nod].value = min(A[2 * nod].value, A[2 * nod + 1].value);
}


void Query(int nod, int st, int dr, int a, int b) 
{
    if (a <= st && dr <= b) 
    {
        minim = min(minim, A[nod].value);
        return;
    }
	
	PushDown(nod);

	int mid = (st + dr)/2;
	if (a <= mid)
		Query(2 * nod, st, mid, a, b);
	if (b > mid)
		Query(2 * nod + 1, mid + 1, dr, a, b);

	A[nod].value = min(A[2 * nod].value, A[2 * nod + 1].value);
}

 
void Update(int nod, int st, int dr, int a, int b, int x) 
{
    if (a <= st && dr <= b) 
    {
        A[nod].value = x;
        A[nod].lazy = 1;
        return;

    } 

	PushDown(nod); // propagare spre fii

	int mid = (st + dr) / 2;
	if (a <= mid)
		Update(2 * nod, st, mid, a, b, x);
	if (b > mid)
		Update(2 * nod + 1, mid + 1, dr, a, b, x);
	A[nod].value = min(A[2 * nod].value, A[2 * nod + 1].value);
}
